/* ------------------------------------------------------ */
/*                    ARITHMET.PRO                        */
/*       (c) 1991 Burkhard R. Wittek & DMV-Verlag         */
/*   Ausdrcke von ganzen Zahlen ohne negative Zahlen     */
/* ------------------------------------------------------ */

expression(e,<x,y>) -> sum(e,<x,y>);

sum(e,<x,y>) -> product(p,<x,z>) rest-of-sum(p,e,<z,y>);
sum(e,<x,y>) -> division(p,<x,z>) rest-of-sum(p,e,<z,y>);

product(p,<x,y>) -> primary(f,<x,z>)
                    rest-of-product(f,p,<z,y>);

division(p,<x,y>) -> primary(f,<x,z>)
                     rest-of-division(f,p,<z,y>);

primary(n,<x,y>) -> word(n,<x,y>) integer(n);
primary(e,<x,y>) ->
   word("(",<x,z>)
   expression(e,<z,t>)
   word(")",<t,y>);

rest-of-sum(p,<o-a,p,p'>,<x,y>) ->
   word(o,<x,z>)
   op-add(o,o-a)
   sum(p',<z,y>);
rest-of-sum(e,e,<x,x>) ->;

rest-of-product(f,<o-m,f,f'>,<x,y>) ->
   word(o,<x,z>)
   op-mul(o,o-m)
   product(f',<z,y>);
rest-of-product(f,f,<x,x>) ->;

rest-of-division(f,<o-m,f,f'>,<x,y>) ->
   word(o,<x,z>)
   op-div(o,o-m)
   dif(f',0)
   division(f',<z,y>);
rest-of-division(f,f,<x,x>) ->;

word(a,<a.x,x>) ->;

op-add("+",add) ->;
op-add("-",sub) ->;

op-div("/",div) ->;

op-mul("*",mul) ->;

lese(nil) -> next-char'(".") / in-char'(".");
lese(a.b) -> in-ident(a) / lese(b);
lese(a.b) -> in-integer(a) / lese(b);
lese(a.b) -> in-char'(a) lese(b);

start(e) ->  % e = Variable zur semantischen Darstellung
   repeat
   line
   outm("der Ausdruck ")
   lese(p)
   analysiere(p,e)
   val(e,f)
   outm(" ergibt...    ")
   out(f)
   fail;
start ->
   repeat
   line
   outm("der Ausdruck ")
   lese(p)
   analysiere(p,e)
   outl(e)
   val(e,f)
   outm(" ergibt...    ")
   out(f)
   fail;

repeat ->;
repeat -> repeat;

analysiere(p,e) -> expression(e,<p,nil>) /;
analysiere(p,e) -> outm("...  ist nicht wohlgeformt") fail;

;End world: Normal
/* ------------------------------------------------------ */
/*                Ende von ARITHMET.PRO                   */

